package com.org.hktshop.Interface.coupon;

import com.org.hktshop.entity.Page;
import com.org.hktshop.entity.product.HktCoupon;

import java.util.List;
import java.util.Map;

/**
 * @author hotking03
 */
public interface HktCouponService {
    /**
     * 新增/修改优惠券信息
     * @param hktCoupon
     */
    void updateCoupon(HktCoupon hktCoupon);

    /**
     * 删除优惠券信息
     * @param hktCoupon
     */
    void delCoupon(HktCoupon hktCoupon);

    /**
     * 查找优惠券信息
     * @param hktCoupon
     * @return
     */
    HktCoupon findCoupon(HktCoupon hktCoupon);

    /**
     * 查找优惠券信息列表(门户)
     * @param hktCoupon
     * @return
     */
    List<HktCoupon> selectCoupon(HktCoupon hktCoupon);

    /**
     * 领取优惠券
     * @param map
     */
    void receiveCoupon(Map<String, String> map);

    /**
     * 已经领取的优惠券
     * @param hktCoupon
     * @return
     */
    List<HktCoupon> alreadyReceiveCoupon(HktCoupon hktCoupon);

    /**
     * 每天凌晨12点更新
     * @return
     */
    void updateStatusCoupon();

    /**
     * 优惠券列表(后台)
     * @param hktCoupon
     * @return
     */
    List<HktCoupon> selectCouponList(HktCoupon hktCoupon);

    /**
     * 修改已使用状态
     * @param sql2
     */
    void updateCouponUser(String sql2);
}
